#include "chdecl.h"
void CH_catargv(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb4;
    case 4: goto c5;
    case 9: goto c8;
    case 5: goto c8;
    case 6: goto cb13;
    case 7: goto c14;
    case 8: goto cb15;
    case 10: goto c17;
    case 11: goto cb20;
    case 12: goto c21;
    case 13: goto c24;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* chs_lit 4 , "stdout" */
  if( !chs_lit(DEF(4),"stdout") ) goto ch_depletion;
/* chs_lit 5 , "stdio" */
  if( !chs_lit(DEF(5),"stdio") ) goto ch_depletion;
  current->ip = 3;
cb4:
/* call 3.2.2 4 5 6 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(4),
          arguments[2] = DEF(5),
          arguments[3] = DEF(6),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* unwrap 7 6 , 2 */
  if ((ch_returncode = che_unwrap(DEF(7),DEF(6),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* copy 8 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val;
  REF(8).tsdr = & dr_table;
/* initget 9 8 , 0,0 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(9),DEF(8),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c16:
c8:
/* get_or_goto 9 8 , 17 */
  if ((ch_returncode = get_selected_object(DEF(9),DEF(8),sched)) != Normal)
     goto c17;
/* position 10 9 */
  ch_frame = get_selector_frame(DEF(9),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(10).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(10).tsdr = &dr_integer;
/* ilt . 10 =(2) , 8 */
  if ( REF(10).value.integer < 2 ) goto c8;
  current->ip = 6;
cb13:
/* call 7.1 9 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7)DOT(1),
          arguments[1] = DEF(9),
          arguments[1+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c14:
/* ordenum_lit 11 , 32 */
  REF(11).value.ord_enum = 32;
  REF(11).tsdr = & dr_ord_enumeration;
  current->ip = 8;
cb15:
/* call 7.0 11 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7)DOT(0),
          arguments[1] = DEF(11),
          arguments[1+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c17:
/* endget 9 8 */
  end_selector(DEF(9),DEF(8),sched,GET);
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* ordenum_lit 12 , 10 */
  REF(12).value.ord_enum = 10;
  REF(12).tsdr = & dr_ord_enumeration;
  current->ip = 11;
cb20:
/* call 7.0 12 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(7)DOT(0),
          arguments[1] = DEF(12),
          arguments[1+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c21:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c24:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
